FCT = {}
FCT_conf = {}
FCT.lang = FCT_lang[Inspect.System.Language()]
FCT.context = UI.CreateContext("FCT.context")

local settings = {
	output = {anchor = {"TOPLEFT", UIParent, "TOPLEFT", 360, 380}, bgcolor = {0, 0.4, 0}, point = "CENTERBOTTOM", pointto = "CENTERTOP", yoffset = -2, damage = {1, 0.8, 0}, heal = {0, 0.8, 0},},
	input = {anchor = {"TOPLEFT", UIParent, "TOPLEFT", 360, 540}, bgcolor = {0.8, 0, 0}, point = "CENTERTOP", pointto = "CENTERBOTTOM", yoffset = 2, damage = {1, 0.2, 0}, heal = {0, 0.4, 1},},
}

for obj, v in pairs(settings) do
	FCT[obj] = {}
	for i = 1, 10 do
		FCT[obj]["string"..i] = UI.CreateFrame("Frame", "FCT."..obj.."string"..i, FCT.context)
		FCT[obj]["string"..i]:SetWidth(280)
		FCT[obj]["string"..i]:SetHeight(24)
		--FCT[obj]["string"..i]:SetBackgroundColor(0, 0, 0) -- !!!!!!!!!!!!!!!!
		FCT[obj]["string"..i]:SetVisible(false)
		
		FCT[obj]["string"..i].icon = UI.CreateFrame("Texture", "FCT."..obj..".string"..i..".icon", FCT[obj]["string"..i])
		FCT[obj]["string"..i].icon:SetWidth(24)
		FCT[obj]["string"..i].icon:SetHeight(24)
		FCT[obj]["string"..i].icon:SetPoint("CENTER", FCT[obj]["string"..i], "CENTER")
		
		FCT[obj]["string"..i].unit = UI.CreateFrame("Text", "FCT."..obj..".string"..i..".unit", FCT[obj]["string"..i])
		FCT[obj]["string"..i].unit:SetWidth(128)
		FCT[obj]["string"..i].unit:SetFontSize(12)
		FCT[obj]["string"..i].unit:SetWordwrap(true)
		FCT[obj]["string"..i].unit:SetPoint("CENTERLEFT", FCT[obj]["string"..i].icon, "CENTERRIGHT")
		--FCT[obj]["string"..i].unit:SetText("Unit") -- 
		
		FCT[obj]["string"..i].unitshadow = UI.CreateFrame("Text", "FCT."..obj..".string"..i..".unitshadow", FCT[obj]["string"..i])
		FCT[obj]["string"..i].unitshadow:SetLayer(-1)
		FCT[obj]["string"..i].unitshadow:SetWidth(128)
		FCT[obj]["string"..i].unitshadow:SetFontSize(12)
		FCT[obj]["string"..i].unitshadow:SetWordwrap(true)
		FCT[obj]["string"..i].unitshadow:SetFontColor(0, 0, 0)
		FCT[obj]["string"..i].unitshadow:SetPoint("CENTER", FCT[obj]["string"..i].unit, "CENTER", 1, 1)
		--FCT[obj]["string"..i].unitshadow:SetText("Unit") -- 
		
		FCT[obj]["string"..i].value = UI.CreateFrame("Text", "FCT."..obj..".string"..i..".value", FCT[obj]["string"..i])
		FCT[obj]["string"..i].value:SetFontSize(20)
		FCT[obj]["string"..i].value:SetPoint("CENTERRIGHT", FCT[obj]["string"..i].icon, "CENTERLEFT")
		--FCT[obj]["string"..i].value:SetText("Value"..i) -- 
		
		FCT[obj]["string"..i].valueshadow = UI.CreateFrame("Text", "FCT."..obj..".string"..i..".valueshadow", FCT[obj]["string"..i])
		FCT[obj]["string"..i].valueshadow:SetLayer(-1)
		FCT[obj]["string"..i].valueshadow:SetFontSize(20)
		FCT[obj]["string"..i].valueshadow:SetFontColor(0, 0, 0)
		FCT[obj]["string"..i].valueshadow:SetPoint("CENTER", FCT[obj]["string"..i].value, "CENTER", 1, 1)
		--FCT[obj]["string"..i].valueshadow:SetText("Value"..i) -- 
		
		if i == 1 then
			FCT[obj]["string"..i]:SetPoint(unpack(settings[obj].anchor))
		else
			FCT[obj]["string"..i]:SetPoint(settings[obj].point, FCT[obj]["string"..i - 1], settings[obj].pointto, 0, settings[obj].yoffset)
		end
		
		FCT[obj]["string"..i].Event.MouseIn = function()
			if FCT[obj]["string"..i].ability then
				Command.Tooltip(FCT[obj]["string"..i].ability)
			end
		end
		
		FCT[obj]["string"..i].Event.MouseOut = function()
			Command.Tooltip(nil)
		end
	end
	
	FCT[obj].bg = UI.CreateFrame("Frame", "FCT."..obj..".bg", FCT[obj].string1)
	FCT[obj].bg:SetLayer(-1)
	FCT[obj].bg:SetWidth(280)
	FCT[obj].bg:SetHeight(260)
	FCT[obj].bg:SetBackgroundColor(unpack(settings[obj].bgcolor))
	FCT[obj].bg:SetPoint(settings[obj].point, FCT[obj].string1, settings[obj].point)
	FCT[obj].bg:SetVisible(false)
	
	FCT[obj].bg.text = UI.CreateFrame("Text", "FCT."..obj..".bg.text", FCT[obj].bg)
	FCT[obj].bg.text:SetFontSize(18)
	FCT[obj].bg.text:SetFontColor(1, 1, 1)
	FCT[obj].bg.text:SetText(FCT.lang[obj])
	FCT[obj].bg.text:SetPoint(settings[obj].point, FCT[obj].string1, settings[obj].point)
	
	
	
	FCT[obj].mouse = {}
	
	FCT[obj].string1.Event.LeftDown = function()
		if FCT.move then
			local cursor = Inspect.Mouse()
			FCT[obj].mouse.pressed = true
			FCT[obj].mouse.x = cursor.x - FCT[obj].string1:GetLeft()
			FCT[obj].mouse.y = cursor.y - FCT[obj].string1:GetTop()
		end
	end

	FCT[obj].string1.Event.MouseMove = function()
		if FCT[obj].mouse.pressed and FCT.move then
			local cursor = Inspect.Mouse()
			FCT[obj].string1:SetPoint("TOPLEFT", UIParent, "TOPLEFT", cursor.x - FCT[obj].mouse.x, cursor.y - FCT[obj].mouse.y)
		end
	end

	FCT[obj].string1.Event.LeftUp = function()
		if FCT[obj].mouse.pressed and FCT.move then
			FCT_conf[obj].x = FCT[obj].string1:GetLeft()
			FCT_conf[obj].y = FCT[obj].string1:GetTop()
			FCT[obj].mouse.pressed = nil
		end
	end
end


function FCT.OnLoad(addon)
	if addon == "fCombatTracker" then
		for obj, v in pairs(settings) do
			if not FCT_conf[obj] then
				FCT_conf[obj] = {}
				
				FCT_conf[obj].x = FCT[obj].string1:GetLeft()
				FCT_conf[obj].y = FCT[obj].string1:GetTop()
				FCT_conf[obj].on = true
			end
			
			FCT[obj].string1:SetPoint("TOPLEFT", UIParent, "TOPLEFT", FCT_conf[obj].x, FCT_conf[obj].y)
		end
		
		print(FCT.lang.loaded)
	end
end

function FCT.OnSlash()
	if FCT.move then
		for obj, v in pairs(settings) do
			FCT[obj].bg:SetVisible(false)
			FCT[obj].string1:SetVisible(false)
		end
		FCT.move = nil
	else
		for obj, v in pairs(settings) do
			FCT[obj].bg:SetVisible(true)
			FCT[obj].string1:SetVisible(true)
			FCT[obj].string1:SetAlpha(1)
		end
		FCT.move = true
	end
end


function FCT.OnDamage(info)
	local player = Inspect.Unit.Lookup("player")
	local obj, unit, value, size, fired, r, g, b
	if player == info.target then
		fired = Inspect.Time.Real()
		obj = "input"
		r, g, b = unpack(settings.input.damage)
		unit, value, size = FCT.SetData(info.casterName, info.damage, info.overkill, info.crit)
	elseif player == info.caster then
		fired = Inspect.Time.Real()
		obj = "output"
		r, g, b = unpack(settings.output.damage)
		unit, value, size = FCT.SetData(info.targetName, info.damage, info.overkill, info.crit)
	end
	if value then
		FCT.SetValue(obj, info.ability, unit, value, size, fired, r, g, b)
	end
end

function FCT.OnHeal(info)
	local player = Inspect.Unit.Lookup("player")
	local obj, unit, value, size, fired, r, g, b
	if player == info.target then
		fired = Inspect.Time.Real()
		obj = "input"
		r, g, b = unpack(settings.input.heal)
		unit, value, size = FCT.SetData(info.casterName, info.heal, info.overheal, info.crit)
	elseif player == info.caster then
		fired = Inspect.Time.Real()
		obj = "output"
		r, g, b = unpack(settings.output.heal)
		unit, value, size = FCT.SetData(info.targetName, info.heal, info.overheal, info.crit)
	end
	if value then
		FCT.SetValue(obj, info.ability, unit, value, size, fired, r, g, b)
	end
end

function FCT.OnDeath(info)
	local player = Inspect.Unit.Lookup("player")
	local obj, unit, value, size, fired, r, g, b
	if player == info.target then
		fired = Inspect.Time.Real()
		obj = "input"
		r, g, b = unpack(settings.input.damage)
		unit, value, size = FCT.SetData(info.casterName, FCT.lang.death)
	elseif player == info.caster then
		fired = Inspect.Time.Real()
		obj = "output"
		r, g, b = unpack(settings.output.damage)
		unit, value, size = FCT.SetData(info.targetName, FCT.lang.death)
	end
	if value then
		FCT.SetValue(obj, info.ability, unit, value, size, fired, r, g, b)
	end
end

function FCT.OnMiss(info)
	local player = Inspect.Unit.Lookup("player")
	local obj, unit, value, size, fired, r, g, b
	if player == info.target then
		fired = Inspect.Time.Real()
		obj = "input"
		r, g, b = unpack(settings.input.damage)
		unit, value, size = FCT.SetData(info.casterName, FCT.lang.miss)
	elseif player == info.caster then
		fired = Inspect.Time.Real()
		obj = "output"
		r, g, b = unpack(settings.output.damage)
		unit, value, size = FCT.SetData(info.targetName, FCT.lang.miss)
	end
	if value then
		FCT.SetValue(obj, info.ability, unit, value, size, fired, r, g, b)
	end
end

function FCT.OnParry(info)
	local player = Inspect.Unit.Lookup("player")
	local obj, unit, value, size, fired, r, g, b
	if player == info.target then
		fired = Inspect.Time.Real()
		obj = "input"
		r, g, b = unpack(settings.input.damage)
		unit, value, size = FCT.SetData(info.casterName, FCT.lang.parry)
	elseif player == info.caster then
		fired = Inspect.Time.Real()
		obj = "output"
		r, g, b = unpack(settings.output.damage)
		unit, value, size = FCT.SetData(info.targetName, FCT.lang.parry)
	end
	if value then
		FCT.SetValue(obj, info.ability, unit, value, size, fired, r, g, b)
	end
end

function FCT.OnDodge(info)
	local player = Inspect.Unit.Lookup("player")
	local obj, unit, value, size, fired, r, g, b
	if player == info.target then
		fired = Inspect.Time.Real()
		obj = "input"
		r, g, b = unpack(settings.input.damage)
		unit, value, size = FCT.SetData(info.casterName, FCT.lang.dodge)
	elseif player == info.caster then
		fired = Inspect.Time.Real()
		obj = "output"
		r, g, b = unpack(settings.output.damage)
		unit, value, size = FCT.SetData(info.targetName, FCT.lang.dodge)
	end
	if value then
		FCT.SetValue(obj, info.ability, unit, value, size, fired, r, g, b)
	end
end

function FCT.OnImmune(info)
	local player = Inspect.Unit.Lookup("player")
	local obj, unit, value, size, fired, r, g, b
	if player == info.target then
		fired = Inspect.Time.Real()
		obj = "input"
		r, g, b = unpack(settings.input.damage)
		unit, value, size = FCT.SetData(info.casterName, FCT.lang.immune)
	elseif player == info.caster then
		fired = Inspect.Time.Real()
		obj = "output"
		r, g, b = unpack(settings.output.damage)
		unit, value, size = FCT.SetData(info.targetName, FCT.lang.immune)
	end
	if value then
		FCT.SetValue(obj, info.ability, unit, value, size, fired, r, g, b)
	end
end

function FCT.OnResist(info)
	local player = Inspect.Unit.Lookup("player")
	local obj, unit, value, size, fired, r, g, b
	if player == info.target then
		fired = Inspect.Time.Real()
		obj = "input"
		r, g, b = unpack(settings.input.damage)
		unit, value, size = FCT.SetData(info.casterName, FCT.lang.resist)
	elseif player == info.caster then
		fired = Inspect.Time.Real()
		obj = "output"
		r, g, b = unpack(settings.output.damage)
		unit, value, size = FCT.SetData(info.targetName, FCT.lang.resist)
	end
	if value then
		FCT.SetValue(obj, info.ability, unit, value, size, fired, r, g, b)
	end
end

function FCT.OnUpdate()
	for obj, v in pairs(settings) do
		for i = 1, 10 do
			if FCT[obj]["string"..i].fired then
				if Inspect.Time.Real() - FCT[obj]["string"..i].fired > 10 then
					FCT[obj]["string"..i]:SetAlpha(FCT[obj]["string"..i]:GetAlpha() - 0.01)
					if FCT[obj]["string"..i]:GetAlpha() <= 0 then
						FCT[obj]["string"..i]:SetVisible(false)
						FCT[obj]["string"..i].fired = nil
					end
				end
			end
		end
	end
end

table.insert(Command.Slash.Register("fct.move"), {FCT.OnSlash, "fCombatTracker", "FCT.OnSlash" })
table.insert(Event.Addon.Load.End, {FCT.OnLoad, "fCombatTracker", "FCT.OnLoad"})
table.insert(Event.Combat.Damage, {FCT.OnDamage, "fCombatTracker", "FCT.OnDamage"})
table.insert(Event.Combat.Heal, {FCT.OnHeal, "fCombatTracker", "FCT.OnHeal"})
table.insert(Event.Combat.Death, {FCT.OnLoad, "fCombatTracker", "FCT.OnDeath"})
table.insert(Event.Combat.Miss, {FCT.OnMiss, "fCombatTracker", "FCT.OnMiss"})
table.insert(Event.Combat.Parry, {FCT.OnParry, "fCombatTracker", "FCT.OnParry"})
table.insert(Event.Combat.Dodge, {FCT.OnDodge, "fCombatTracker", "FCT.OnDodge"})
table.insert(Event.Combat.Immune, {FCT.OnImmune, "fCombatTracker", "FCT.OnImmune"})
table.insert(Event.Combat.Resist, {FCT.OnResist, "fCombatTracker", "FCT.OnResist"})
table.insert(Event.System.Update.Begin, {FCT.OnUpdate, "fCombatTracker", "FCT.OnUpdate"})


function FCT.SetValue(obj, ability, unit, value, size, fired, r, g, b)
	for i = 10, 2, -1 do
		if FCT[obj]["string"..i - 1].fired then
			FCT[obj]["string"..i].fired = FCT[obj]["string"..i - 1].fired
			FCT[obj]["string"..i].ability = FCT[obj]["string"..i - 1].ability
			
			local source, texture = FCT[obj]["string"..i - 1].icon:GetTexture()
			if texture then
				FCT[obj]["string"..i].icon:SetTexture("Rift", texture)
			else
				FCT[obj]["string"..i].icon:SetTexture("Rift", "")
			end
			
			FCT[obj]["string"..i].unit:SetText(FCT[obj]["string"..i - 1].unit:GetText())
			local r, g, b = FCT[obj]["string"..i - 1].unit:GetFontColor()
			FCT[obj]["string"..i].unit:SetFontColor(r, g, b)
			
			FCT[obj]["string"..i].unitshadow:SetText(FCT[obj]["string"..i - 1].unitshadow:GetText())
			
			FCT[obj]["string"..i].value:SetText(FCT[obj]["string"..i - 1].value:GetText())
			FCT[obj]["string"..i].value:SetFontSize(FCT[obj]["string"..i - 1].value:GetFontSize())
			local r, g, b = FCT[obj]["string"..i - 1].value:GetFontColor()
			FCT[obj]["string"..i].value:SetFontColor(r, g, b)
			
			FCT[obj]["string"..i].valueshadow:SetText(FCT[obj]["string"..i - 1].valueshadow:GetText())
			FCT[obj]["string"..i].valueshadow:SetFontSize(FCT[obj]["string"..i - 1].valueshadow:GetFontSize())
			
			FCT[obj]["string"..i]:SetAlpha(FCT[obj]["string"..i - 1]:GetAlpha())
			FCT[obj]["string"..i]:SetVisible(true)
		end
	end
	
	FCT[obj].string1.fired = fired
	FCT[obj].string1.ability = ability
	if ability then
		if Inspect.Ability.Detail(ability).icon then
			FCT[obj].string1.icon:SetTexture("Rift", Inspect.Ability.Detail(ability).icon)
		else
			FCT[obj].string1.icon:SetTexture("Rift", "")
		end
	else
		FCT[obj].string1.icon:SetTexture("Rift", "")
	end
	FCT[obj].string1.unit:SetText(unit)
	FCT[obj].string1.unit:SetFontColor(r, g, b)
	FCT[obj].string1.unitshadow:SetText(unit)
	FCT[obj].string1.value:SetText(value)
	FCT[obj].string1.value:SetFontSize(size)
	FCT[obj].string1.value:SetFontColor(r, g, b)
	FCT[obj].string1.valueshadow:SetText(value)
	FCT[obj].string1.valueshadow:SetFontSize(size)
	FCT[obj].string1:SetAlpha(1)
	FCT[obj].string1:SetVisible(true)
end

function FCT.SetData(_unit, _value, _over, _crit)
	local unit, value, size
	size = 16
	color = _color
	if _unit then
		unit = _unit
	else
		unit = ""
	end
	if _value then
		if type(_value) == "number" then
			value = tostring(_value)
			if _over then
				value = tostring(_value + _over)
			end
		elseif type(_value) == "string" then
			value = _value
		end
	end
	if _crit then
		size = 24
	end
	return unit, value, size
end
